//KolibriOS functions

void __kolibri__winresize(__u16 xsize, __u16 ysize)
{
	__asm__ __volatile__("int $0x40"::"a"(67),"b"(-1),"c"(-1),"d"(xsize),"S"(ysize));
}

void __kolibri__setkbmode(__u8 mode)
{
	__asm__ __volatile__("int $0x40"::"a"(66),"b"(1),"c"(mode));
}

void __kolibri__getasciimap(char* map)
{
	__asm__ __volatile__("int $0x40"::"a"(26),"b"(2),"c"(1),"d"((__u32)map));
}

void __kolibri__draw_title(char* Title)
{
	__asm__ __volatile__("int $0x40"::"a"(71),"b"(1),"c"(Title));
}

__u32 __kolibri__getticks(void)
{
 __u32 __ret;
 __asm__ __volatile__("int $0x40":"=a"(__ret):"0"(26),"b"(9));
 return __ret;
}

int __kolibri__wait_for_event_timed(int time)
{
 __u32 __ret;
 __asm__ __volatile__("int $0x40":"=a"(__ret):"0"(23),"b"((__u32)time));
 return __ret;
}


/*
int __kolibri__getcurdir(char* CurDir)
{
	int len=0;
	__asm__ __volatile__("int $0x40":"=a"(len):"a"(30),"b"(2),"c"((__u32)CurDir),"d"(2048));
	return len;
}
*/

int __kolibri__mkdir(char* CurDir)
{
	struct systree_info finf;
	int ret=0;

	finf.command = 9;
	finf.file_offset_low = 0;
	finf.file_offset_high = 0;
	finf.size = 0;
	finf.data_pointer = 0;
	finf._zero = 0;
	finf.nameptr = CurDir;
	return __kolibri__system_tree_access(&finf);
}

__u32 __kolibri__getmousedata(__u16 *x, __u16 *y)
{
	__u32 	__buttons=0;
	__u32 	__coord=0;
	__asm__ __volatile__("int $0x40":"=a"(__coord):"0"(37),"b"(1));
	*y = (__coord & 0xFFFF);
	*x = (__coord >> 16);
	__asm__ __volatile__("int $0x40":"=a"(__buttons):"0"(37),"b"(2));
	return  __buttons;
}

void __kolibri__debug_out_byte(__u8 ch){
	__asm__ __volatile__("int $0x40"::"a"(63),"b"(1),"c"(ch));
}

void __kolibri__debug_out(const char* str){
  while(*str)
    __kolibri__debug_out_byte(*str++);
}

__u32 __kolibri__reserve_ports(__u16 first, __u16 last, __u8 on){
	__u32 __ret;
	__asm__ __volatile__("int $0x40":"=a"(__ret):"0"(46),"b"(on),"c"(first),"d"(last));
	return __ret;
}
